const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const banks = sequelize.define(
    'banks',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

code: {
        type: DataTypes.TEXT,
      
      

      },

name: {
        type: DataTypes.TEXT,
      
      

      },

swift: {
        type: DataTypes.TEXT,
      
      

      },

website: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  banks.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























    db.banks.hasMany(db.bank_accounts, {
      as: 'bank_accounts_bank',
      foreignKey: {
          name: 'bankId',
      },
      constraints: false,
    });


    db.banks.hasMany(db.letters_of_credit, {
      as: 'letters_of_credit_bank',
      foreignKey: {
          name: 'bankId',
      },
      constraints: false,
    });























//end loop



    db.banks.belongsTo(db.businesses, {
      as: 'business',
      foreignKey: {
        name: 'businessId',
      },
      constraints: false,
    });




    db.banks.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.banks.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return banks;
};


